module
#include "../expr/einfo.t.t"
#include "../expr/ttype.t.t"
#include "../expr/id.t.t"
#include "../expr/id.t"
#include "../expr/constr.t.t"
#include "../Expr/Expr.t.t"
#include "../misc/flags.t"
#include "../funnos.h"
#include "Gseq.t"
#include "Genv.t"
#include "Gcodedef.t.t"
#include "Gmode.t.t"
#include "Gcode.t"
/*import G: Gmode->Expr->Genv->Int->Glabel->Int ->
		(Glabel->((List Gcode)#Glabel)){FTFFFF,F};*/

export 	Gjmp, Gpop, Gslide, Gcpushrev, pushvar, updstack,
	prebasicconstr, prebasicop, gnoargs,
	bigop, Gspark, Gdoeval, Eisconst, Gmethod;
rec
    Gjmp R l = Gi []
 || Gjmp _ l = Gi [ JMP l ]
and Gpop 0 = Gi []
 || Gpop n = Gi [ POP n ]
and Gslide 0 = Gi []
 || Gslide n = Gseq[ Gi [ MOVE n ]; Gpop (n-1) ]
and Gcpushrev el r n = Gseq (map (\(e,n).G (C n) e r n Notalabel 0)
		                  (combine (reverse el, from n)))

and prebasicop Fadd   = ADD
 || prebasicop Fsub   = SUB
 || prebasicop Fmul   = MUL
 || prebasicop Fdiv   = DIV
 || prebasicop Fmod   = MOD
 || prebasicop Fneg   = NEG
 || prebasicop Feq    = EQ
 || prebasicop Fne    = NE
 || prebasicop Flt    = LT
 || prebasicop Fle    = LE
 || prebasicop Fgt    = GT
 || prebasicop Fge    = GE
 || prebasicop Fbigeq = EQ
 || prebasicop Fbigne = NE
 || prebasicop Fbiglt = LT
 || prebasicop Fbigle = LE
 || prebasicop Fbiggt = GT
 || prebasicop Fbigge = GE
 || prebasicop Ford   = ORD
 || prebasicop Fchr   = CHR
 || prebasicop Ftag   = TAG

and prebasicconstr Fadd = Gbint
||  prebasicconstr Fsub = Gbint
||  prebasicconstr Fmul = Gbint
||  prebasicconstr Fdiv = Gbint
||  prebasicconstr Fmod = Gbint
||  prebasicconstr Fneg = Gbint
||  prebasicconstr Ford = Gbint
||  prebasicconstr Fchr = Gbchar
||  prebasicconstr Feq = Gbtag
||  prebasicconstr Fne = Gbtag
||  prebasicconstr Flt = Gbtag
||  prebasicconstr Fle = Gbtag
||  prebasicconstr Fgt = Gbtag
||  prebasicconstr Fge = Gbtag
||  prebasicconstr Fbigeq = Gbtag
||  prebasicconstr Fbigne = Gbtag
||  prebasicconstr Fbiglt = Gbtag
||  prebasicconstr Fbigle = Gbtag
||  prebasicconstr Fbiggt = Gbtag
||  prebasicconstr Fbigge = Gbtag
||  prebasicconstr Ftag   = Gbtag

and gnoargs i = arity_of_id i
and push i r n =
	case lookenv r i in
	   0: Gi [ PUSHGLOBAL i ]
	|| m: Gi [ PUSH (n-m) ]
	end
and pushvar i r n s =
		Gseq [  push i r n;
			Gslide (n-s)
		]
and updstack i r n =
    if Indir then
	case lookenv r i in
	   0: Gi []
	|| m: Gi [PUSH 0; MOVE (n-m+2)]
	end
    else
	Gi []
and bigop n = mem n [Fbigeq; Fbigne; Fbigle; Fbigge; Fbiglt; Fbiggt]
and Gspark is r n =
--	Gseq (map (\i.Gseq [push i r n; Gi [SPARK]]) is)
	Gseq []
and Gdoeval is r n =
	Gseq (map (\i.Gseq [push i r n; Gi [EVAL; POP 1]]) is)
and
   Eisconst (Econstr _ el) = all Eisconst el
|| Eisconst (Eidapl i el) & (gnoargs i ~= -1) = all Eisconst el
|| Eisconst _ = false
and Gmethod f n [k] = [f n k]
||  Gmethod f n (k.ks) = GETMETHOD k . Gmethod f n ks
end
