module --curry0
-- Initial transformations, before rename.
#include "../expr/id.t.t"
#include "../expr/types.t.t"
#include "../transform/misc.t"
#include "../syntax/listgen.h"
#include <Option>
export curry0;
rec curry0 e = ff e
and
    ff t =
	case t in
	    mkap (mkap (mkap (mkident (mkids "Pif")) c) t) e : mkif (ff c) (ff t) (ff e)
	|| (mkap f a) :  mkap (ff f) (ff a)
	|| (mklam e1 e) : mklam e1 (ff e)
	|| (mkcase e cl) : mkcase (ff e) (map ffp cl)
	|| (mkletv b e) : mkletv (ffb b) (ff e)
	|| (mkident i) : mkident (ffi i)
        || (mkmodule i _ env _ b) : ff (mkhmodule i None [mkimport (mkids "???") [] [] env false [] []] [] b)	-- can come from the interactive system
	|| (mkconst _) : t
	|| (mkerror _) : t
	|| (mkas i p) : mkas i (ff p)
	|| (mkcondp p c) : mkcondp (ff p) (ff c)
	|| (mklazyp p) : mklazyp (ff p) 
	|| (mkconstr c el) : mkconstr c (map (ff) el)
	|| (mkfailmatch _) : t
	|| (mkinfo t e) : mkinfo t (ff e)
	|| (mklistf n es) : mlistf n (map ff es)
	|| (mklistg e qs) : mklistg (ff e) (map ffq qs)
	|| (mkhmodule a b c d e) : mkhmodule a b c d (ffb e)
	end
and mlistf L_FROM_TO    es = mkapl "_enumFromTo"     es
||  mlistf L_FROM       es = mkapl "_enumFrom"       es
||  mlistf L_FROM_BY_TO es = mkapl "_enumFromThenTo" es
||  mlistf L_FROM_BY    es = mkapl "_enumFromThen"   es
and mkapl s es = reduce (\a.\f.mkap f a) (mkident (mkids s)) (reverse es)
and
    ffq (mkqfilter e) = mkqfilter (ff e)
||  ffq (mkqgen p e) = mkqgen (ff p) (ff e)
and ffb (mkbrec b) = mkbrec (andify (crunchf (map ffb1 (unand b))))
||  ffb b = andify (crunchf (map ffb1 (unand b)))
and ffb1 d =
	case d in
	   mkbpat pl : mkbpat (map ffp pl)
        || mkbmulti p e : mkbmulti (ff p) (ff e)
	|| mkbclass t b : mkbclass t (ffb b)
	|| mkbinstance t b x : mkbinstance t (ffb b) x
	|| d : d
	end
and ffi i = i
and unand (mkband b1 b2) = unand b1 @ unand b2
||  unand b = [b]
and andify [b] = b
||  andify (b.bs) = mkband b (andify bs)
and crunchf (mkbpat [(p, e)].bs) = pickf (leftmost p) [(p, e)] bs
||  crunchf (b.bs) = b.crunchf bs
||  crunchf [] = []
and pickf n pes (mkbpat [(p, e)].bs) & (leftmost p = n) = pickf n ((p,e).pes) bs
||  pickf _ pes bs = mkbpat (reverse pes).crunchf bs
and
    ffp (p, e) = (ff p, ff e)
and mkif c t e = mkcase c [(mtrue, t); (mfalse, e)]
and mtrue = mkident (mkids "_True")
and mfalse = mkident (mkids "_False")
end
