module
/*	CONSTR for user defined types and SPLIT
**
*/
#include "../Gcode/Gcodedef.t.t"
#define N 5 

export mconstr, msplit;

rec
    mconstr n 0 = [ CNIL n ]
 || mconstr n 1 = [ CTAG n ]
 || mconstr n l = let vek 1 = []
		   || vek 2 = [ CPAIR 0 ]
		   || vek l = [ CVEK l ]
		   in if n < N then
		   	vek(l-1) @ [ CPAIR n ]
		      else
		        vek l @ [ CTAG n ]

and msplit bs n 0 = []
 || msplit bs n l = PUSH 0.reverse (f (mconstr n l) bs)
	where rec
	      f (CVEK n.G) bs =
		let cbs = head n bs in
		let b = Or cbs in
		if b then
		    SPLITVEK cbs n. f G (true.tail n bs)
		else
		    f G (false.tail n bs)
	||    f (CPAIR _.G) (b1.b2.bs) =
		if b1|b2 then
		    SPLITPAIR b1 b2. f G (true.bs)
		else
		    f G (false.bs)
	||    f (CTAG _.G) (b.bs) =
		if b then
		    SPLITTAG. f G (b.bs)
		else
		    f G (false.bs)
	||    f [] _ = []
end
